class Ball {
  float x, y;
  float r;  //반지름
  float xspeed,yspeed = 0;
  Ball[] others;

  Ball(float xin, float yin, float din, int idin, Ball[] oin) {
    x = xin;
    y = yin;
    r = din;
    others = oin;
  } 

  void collide() {
    for (int i = 1; i < num; i++) {
      float dx = others[i].x - x;
      float dy = others[i].y - y;
      float distance = sqrt(dx*dx + dy*dy);
      float minDist = others[i].r/2 + r/2;
      if (distance < minDist) { 
        float angle = atan2(dy, dx);
        float targetX = x + cos(angle) * minDist;
        float targetY = y + sin(angle) * minDist;
        float ax = (targetX - others[i].x) * bounce;
        float ay = (targetY - others[i].y) * bounce;
        xspeed -= ax;
        yspeed -= ay;
        others[i].xspeed += ax;
        others[i].yspeed += ay;
      }
    }   
  }

  void move() {

    x += xspeed;
    y += yspeed;    

    if (x + r > width ) {

      xspeed *= friction; 
    }
    else if (x - r*2 < 0) {
      x = r*2;
      xspeed *= friction;
    }
    if (y + r*2 > height) {
      y = height - r*2;
      yspeed *= friction; 
    } 
    else if (y - r*2 < 0) {
      y = r*2;
      yspeed *= friction;
    }
  }

  float R,G,B;

  void display() {
    float R=random(255);
    float G=random(255);
    float B=random(255);
    fill(R,G,B,90);
    ellipse(x, y, r*2, r*2);

  }

}



